# 決済手段 削除

`DELETE /v1/customers/{customer_id}/payment_methods/{id}`

- operationId: `deleteCustomerPaymentMethod`
- tags: 決済手段

`customer_id`で指定した顧客に対し紐づく決済手段のうち、`id`で指定したものを削除します。


## コードサンプル

### cURL

```bash
curl \
    -X DELETE \
    -H "Authorization:Bearer <Secret API Key>" \
'https://api.test.fincode.jp/v1/customers/{customer_id}/payment_methods/{id}?pay_type=Card'
```

### Node.js

```javascript
import fetch from "node-fetch";

const BASE_URL = "https://api.test.fincode.jp";

const API_KEY = "<Secret API Key>";

(async () => {
    const customerId = "<Customer ID>";
    const paymentMethodId = "<Payment Method ID>";

    const queryParams = new URLSearchParams({
        pay_type: "Card",
    });

    const endpoint = `${BASE_URL}/v1/customers/${customerId}/payment_methods/${paymentMethodId}?${queryParams}`;

    const response = await fetch(endpoint, {
        method: "DELETE",
        headers: {
            Authorization: `Bearer ${API_KEY}`,
        },
    });
    const result = await response.json();
})();
```

### Go

```go
package main

import (
	"fmt"
	"log"
	"net/http"
)

func main() {

	apiKey := "<Secret API Key>"

	customerID := "<Customer ID>"
	paymentMethodID := "<Payment Method ID>"

	// リクエストの作成
	req, _ := http.NewRequest(
		"DELETE",
		fmt.Sprintf("https://api.test.fincode.jp/v1/customers/%s/payment_methods/%s", customerID, paymentMethodID),
		nil,
	)
	req.Header.Set("Authorization", fmt.Sprintf("Bearer %s", apiKey))

	params := req.URL.Query()
	params.Add("pay_type", "Card")
	req.URL.RawQuery = params.Encode()

	// リクエストの送信
	client := &http.Client{}
	res, err := client.Do(req)
	if err != nil {
		log.Fatal(err)
	}
	defer res.Body.Close()
}
```

### PHP

```php
<?php

$apiKey = '<Secret API Key>';

$customerId = '<Customer ID>';
$paymentMethodId = '<Payment Method ID>';

$baseUrl = "https://api.test.fincode.jp";
$endpoint = "/v1/customers/{$customerId}/payment_methods/{$paymentMethodId}";
$queryParams = [
    "pay_type" => "Card",
];

$headers = [
    "Authorization: Bearer " . $apiKey,
];

$session = curl_init();
curl_setopt($session, CURLOPT_URL, $baseUrl . $endpoint . "?" . http_build_query($queryParams));
curl_setopt($session, CURLOPT_HTTPHEADER, $headers);
curl_setopt($session, CURLOPT_CUSTOMREQUEST, 'DELETE');
curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
// curl_setopt($session, CURLOPT_SSL_VERIFYPEER, );
// curl_setopt($session, CURLOPT_SSL_VERIFYHOST, );

$response = curl_exec($session);

if ($response === false) {
    # エラー処理
    echo "cURL Error: " . curl_error($session);
} else {
    # APIからのデータを処理
    var_dump($response);
}

curl_close($session);
```

### Python 3

```python
import requests

api_key = '<Secret API Key>'

customer_id = '<Customer ID>'
payment_method_id = '<Payment Method ID>'

url = f'https://api.test.fincode.jp/v1/customers/{customer_id}/payment_methods/{payment_method_id}/'
query_params = {
    'pay_type': 'Card',
}

# ヘッダーを設定
headers = {
    'Authorization': f'Bearer {api_key}',
}

try:
    response = requests.delete(url, headers=headers, params=query_params)

    # レスポンスの処理
    if response.status_code == 200:
        # APIからのデータを処理
        print(f"Success: {response.json()}")
    else:
        # エラーの処理
        print(f"Error: {response.json()}")
except requests.RequestException as e:
    # 通信エラーの処理
    print(f"Request error: {e}")
```

### Ruby

```ruby
require 'net/http'
require 'uri'

API_KEY = '<Secret API Key>'
BASE_URL = 'https://api.test.fincode.jp'

def main
    customer_id = '<Customer ID>'
    payment_method_id = '<Payment Method ID>'
    
    endpoint = "/v1/customers/#{customer_id}/payment_methods/#{payment_method_id}"
    query_params =  {
        limit: 10,
        pay_type: 'Card',
    }

    uri = URI.parse(BASE_URL + endpoint)
    uri.query = URI.encode_www_form(query_params)

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true

    # リクエストの作成
    request = Net::HTTP::Delete.new(uri.request_uri)
    request['Authorization'] = "Bearer #{API_KEY}"

    # リクエストの送信
    response = http.request(request)

    case response
    when Net::HTTPSuccess
        puts 'SUCCESS'
    else
        puts 'ERROR'
    end

    # レスポンスの表示
    puts response.body
end

main
```

## パラメータ

| 名前 | 位置 | 必須 | 型 | 説明 |
| --- | --- | --- | --- | --- |
| `customer_id` | path | ✓ | CustomerId_schema | 顧客ID |
| `id` | path | ✓ | PaymentMethodId_schema | 決済手段ID |
| `Tenant-Shop-Id` | header |  | schema | <span class="smallText color--red-400">※ 顧客情報を共有しないプラットフォームのメインショップのみ指定可</span> |
| `pay_type` | query | ✓ | string | 決済種別 |

## レスポンス

### 200 リクエストに成功

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `id` | PaymentMethod_properties-id |  | 削除された決済手段のIDです。 |
| `pay_type` | enum(Card | Directdebit | Virtualaccount) |  | - `Card` |
| `customer_id` | properties-customer_id |  |  |
| `status` | status |  |  |
| `redirect_url` | redirect_url |  |  |
| `redirect_url_accessed_flag` | redirect_url_accessed_flag |  |  |
| `return_url` | return_url |  |  |
| `return_url_on_failure` | return_url_on_failure |  |  |
| `default_flag` | properties-default_flag |  |  |
| `client_field_1` | client_field_1 |  |  |
| `client_field_2` | client_field_2 |  |  |
| `client_field_3` | client_field_3 |  |  |
| `delete_flag` | properties-delete_flag |  |  |
| `process_date` | properties-process_date |  |  |
| `created` | properties-created |  |  |
| `updated` | properties-updated |  |  |
| `card` | card |  |  |
| `directdebit` | directdebit |  |  |
| `virtualaccount` | virtualaccount |  |  |

### 400 不正なリクエスト

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `errors` | array<FincodeAPIError> |  |  |

